///////////////////////////////////////////////////////////////////////////////////
// A4 main wdl
////////////////////////////////////////////////////////////////////////////
// The PATH keyword gives directories where game files can be found,
// relative to the level directory
path "models";	// Path to model subdirectory - if any
path "sounds";	// Path to sound subdirectory - if any
path "bmaps";		// Path to graphics subdirectory - if any
Path "E:\\PROGRAMME\\GSTUDIO\\template";	// Path to WDL templates subdirectory

////////////////////////////////////////////////////////////////////////////
// The INCLUDE keyword can be used to include further WDL files,
// like those in the TEMPLATE subdirectory, with prefabricated actions
include <movement.wdl>;
include <messages.wdl>;
include <menu.wdl>;		// must be inserted before doors and weapons
include <particle.wdl>; // remove when you need no particles
include <doors.wdl>;		// remove when you need no doors
//include <venture.wdl>;	// include when doing an adventure

////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 6;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode
var zahli;
var coli;
var counter=10;
var sturz=0;
var alarm=0;
/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap city = <bigcity5.pcx>; // the default A4 logo in templates
bmap funken = <fire.pcx>; // the default A4 logo in templates
bmap rauch = <rauch.pcx>; // the default A4 logo in templates
bmap splashmap = <logodark.bmp>; // the default A4 logo in templates
bmap panelbild = <panel.bmp>; // the default A4 logo in templates
bmap panelbild2 = <panel2.bmp>; // the default A4 logo in templates
sound explo = <explo.wex>;
sound rakete = <rak.wex>;
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}
var posmode=1;
var sturz=0;
var t1sturz=0;
var t2sturz=0;
var punktecode=0;
synonym tower1{type entity;}
synonym tower2{type entity;}
synonym towerfall{type entity;}
synonym rohr{type entity;}
synonym flyent{type entity;}
synonym bridgeent{type entity;}
synonym fireent{type entity;}

font benfont=<font.bmp>,12,20;
string alarmstr="Ein Flugzeug ist ins World Trade Center geflogen, \n noch   Sekunden Zeit bis zum Einsturz";
string verlor = "Leider wurde das World Trade Center nicht gerettet";
TEXT    Alarmtext {
LAYER   15;
POS_X   0;
POS_Y   0;
STRINGS 1;
FONT    Benfont;
STRING  alarmstr;
FLAGS    CONDENSED ;
}

// Panel: alarmnr ----- Erstellt am: 14.09.01 16:10:56 
// ========================================================================
PANEL alarmnr {
BMAP  panelbild;
LAYER 16;
POS_X 60;
POS_Y 21;
digits = 0, 0, 2, benfont, 1, counter;
FLAGS REFRESH,OVERLAY;
  }
// ========================================================================
string punktestr = "Punkte:";
TEXT    Punkttext {
LAYER   15;
POS_X   0;
POS_Y   41;
STRINGS 1;
FONT    Benfont;
STRING  punktestr;
FLAGS    CONDENSED;
}

PANEL Punktnr {
BMAP  panelbild;
LAYER 16;
POS_X 100;
POS_Y 41;
digits = 0, 0, 4, benfont, 1, punktecode;
FLAGS REFRESH,OVERLAY;
  }


 string winstr = "Geschafft!! Du hast das World Trade Center gerettet";
TEXT    wintext {
LAYER   15;
POS_X   0;
POS_Y   58;
STRINGS 1;
FONT    Benfont;
STRING  winstr;
FLAGS    CONDENSED;
}

// ========================================================================


/////////////////////////////////////////////////////////////////
// The main() function is started at game start
action tow1{my.skill30=2;tower1=my;}
action tow2{my.skill30=3;tower2=my;}

function main()
{
        coli=0;
	person_3rd = 0.5;
// set some common flags and variables
warn_level = 0;	// anounce bad texture sizes and bad wdl code
	tex_share = on;	// map entities share their textures

// center the splash screen for non-640x480 resolutions
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
// display the splash screen
	splashscreen.visible = on;
// wait 3 frames (for triple buffering) until it is rendered and flipped to the foreground
	wait(3);

// now load the level
	load_level(<1.WMB>);
// wait the required second, then switch the splashscreen off.
waitt(80);
punkttext.visible=on;
punktnr.visible=on;
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory

// load some global variables, like sound volume
	load_status();

//	client_move();	// for a possible multiplayer game
scene_map=city;
scene_angle.tilt=-80;
camera.fog=0;
//fog_color=1;
// call further functions here...
zufallfly();
einsturz();
}
function einsturz{
if (wintext.visible!=on){
while (1){
 if (coli>0)&&(alarmnr.visible==on){
   counter -=1;
   if (counter<=0){
     //if (sturz==1){towerfall=tower1;t1sturz=1;}else{towerfall=tower2;t2sturz=1;}
     if (towerfall==tower1){t1sturz=1;tower1=null;}else{t2sturz=1;tower2=null;}
if (alarmnr.visible==on){alarmtext.visible=off;alarmnr.visible=off;};
     play_soundfile(<mine.wex>,100);
     sturz=result;
     while (towerfall.z>-700){
       towerfall.z-=15*time;
       if (flyent!=null){
         if (flyent.z>50){
           flyent.z-=13*time;
         }
        }

        emit(50,towerfall.x,rauchfunk);
       wait 1;
     }
     towerfall.z=50;
     stop_sound(sturz);
     sturz=0;
     play_soundfile(<mine.wex>,100);

     morph (<schutt.mdl>,towerfall);
     towerfall.scale_x=10;
     towerfall.scale_y=10;
     towerfall.scale_z=10;

     if (coli>0){
       coli-=1;
     }
     if (t2sturz==1)&&(t1sturz==1){
       alarmtext.visible=on;
       alarmtext.string=verlor;
     }


   }
 }
waitt(16);
}
}
}
function flyev{
//breakpoint;
if (wintext.visible!=on){
if (event_type==event_scan){
wait (1);
if (coli>0){coli-=1;if (alarmnr.visible==on){alarmtext.visible=off;alarmnr.visible=off;};}
if (t1sturz==0){punktecode+=75;}
if (t2sturz==0){punktecode+=75;}
if (punktecode>5000){wintext.visible=on;}
play_sound (explo, 100);
if (alarm!=0){stop_sound(alarm);alarm=0;};

remove me;
} else{
if (you==tower1)||(you==tower2){
towerfall=you;
alarmtext.visible=on;
alarmnr.visible=on;
counter=10;
coli+=1;
flyent=my;
if (alarm!=0){stop_sound(alarm);alarm=0;};
play_soundfile(<alarm.wex>,100);
alarm=result;
return;
}
}
}
}
function fly_spur{

if (my_age==0){
my_color.red=255-random(30);
my_color.green=random(30);
my_color.blue=random(30);
my_map=funken;
my_size=400;
my_flare=on;
}
if (my_age>random(20)+5){my_action=null;}
my_speed.x+=0.3-random(0.6);
my_speed.y+=0.3-random(0.6);
my_speed.z+=0.3-random(0.6);

}
function fly{
if (wintext.visible!=on){
set my.event, flyev;
set my.enable_scan, on;
set my.enable_entity, on;
while (1){
temp.x=5;
temp.y=0;
temp.z=0;
move_mode=ignore_passable;
ent_move(temp,nullskill);
if (result==0){break;}
ent_vertex (temp,34);
EMIT( 10, temp, fly_spur);
ent_vertex (temp,60);
EMIT( 10, temp, fly_spur);

wait (1);
}
}
}
function createfly{
if (wintext.visible!=on){
zahli=0;
while(1){
zahli+=1;
if (zahli<30){
temp.z=3000+random(1000);
temp.x=3000-random(6000);
temp.y=2000-random(4000);
} else {
temp.z=3000;
temp.x=0;
temp.y=-2000;

}
if (abs(temp.x)+abs(temp.y)>2000){
create (<boing747.mdl>,temp,fly);
temp.x=0;
temp.y=0;
temp.z=1300;
vec_sub(temp,you.x);
vec_to_angle (you.pan,temp);

//you.pan=
return;
}
}
}
}
function zufallfly{

while (1){
createfly();
waitt (random(100)+200);
if (wintext.visible==on){return;}
if (t1sturz!=0)&&(t2sturz!=0){return;}
}
}
action setrohr{

rohr=my;
player2=my;
while (1){
if (key_cud==1){ if (my.skill44<70){my.skill44+=2;} }
if (key_cuu==1){ if (my.skill44>-50){my.skill44-=2;} }
my.tilt=player.tilt+my.skill44;
move_view();
camera.tilt=my.tilt;
wait (1);
}}
action benplayer{
my.skill44=5;
my.skill48=my.skill8;
if (my.skill8==1){player=my;ent_vertex(temp,1);create(<fire2.mdl>,temp,setrohr;fireup(); }
while (1) {
if (posmode==my.skill48){
player=my;
temp.z=0;
temp.y=0;
temp.x=0;
my.pan+=(-key_force.x) *5;

if (my.skill48==1)&&(t1sturz==0)&&(t2sturz==0){
if (key_del==1){ temp.x=0.5;}
if (key_end==1){ temp.x=-0.5;}
//if (my.skill41>3)&&(temp.x<0) {my.skill41=3;}
//if (my.skill41<-3)&&(temp.x>0) {my.skill41=-3;}
my.skill41+=temp.x;
if (my.skill41>10){my.skill41=10;};
if (my.skill41<-10){my.skill41=-10;};
my.x+=my.skill41;
if (my.x>900){my.x=900;};
if (my.x<-900){my.x=-900;};

}


ent_vertex(temp,1);
vec_set(rohr.x,temp);
rohr.pan=my.pan;
rohr.roll=my.roll;


}
wait 1;
}
}
function firefunk{
if (my_age==0){
my_color.red=255-random(30);
my_color.green=random(30);
my_color.blue=random(30);
my_map=funken;
my_size=400;
my_flare=on;

}
if (my_age>random(20)+5){my_action=null;}
my_speed.x+=1-random(2);
my_speed.y+=1-random(2);
my_speed.z+=1-random(2);
}
/*function rakev{
if ((you!=player)&&(you!=player2)){
wait(1);
remove you;
}
} */
function rakfire{
my.skill1=1;
my.skill2=5;
my.pan=rohr.pan;
my.tilt=rohr.tilt;
my.roll=rohr.roll;
my.skill30=1;
//set my.event,rakev;
//set my.enable_scan, on;
while (1) {
my.skill2+=time;
if (my.skill2>100){emit(300,my.x,firefunk);break;};
if (my==null){break;}
if (player!=null){
you=player;
}
temp.y=0;
temp.z=0;
move_mode=ignore_you;
my.skill1+=0.5;
if (my.skill1>45){my.skill1=45;}
//temp.x=my.skill1;
temp.x=my.skill1;
ent_move(temp,nullskill);
if (result==0) {emit(300,my.x,firefunk);break;}
wait 1;
}
temp.pan = 360;
temp.tilt = 360;
temp.z = 200;
scan_entity(my.x,temp);

wait (6);
remove me;

}
function fire{
if (rohr!=null){
my=rohr;
play_sound(rakete,90);
ent_vertex(temp,27);
create (<rak.mdl>,temp,rakfire);
}
}
on_space fire;
function setpos1{posmode=1;}
function setpos2{posmode=2;}
function setpos3{posmode=3;}
function setpos4{posmode=4;}

on_1 setpos1;
on_2 setpos2;
on_3 setpos3;
on_4 setpos4;
action brigde{
while (1){
if (t1sturz!=0)||(t2sturz!=0){
if (my.z>50){my.z-=15*time;my.roll+=5*time;my.tilt+=5*time;}
}
wait(1) ;
}
}
action fireup{
while (1){
if (t1sturz!=0)||(t2sturz!=0){
if (my.z>50){my.z-=15*time;my.roll+=5*time;my.tilt+=5*time;}
}
wait(1);
}

}
function rauchfunk{
if (my_age==0){
my_color.red=255-random(30);
my_color.green=255-random(30);
my_color.blue=255-random(30);
my_map=rauch;
my_size=400;
my_flare=on;

}
if (my_age>random(50)+5){my_action=null;}
my_speed.x+=2-random(4);
my_speed.y+=2-random(4);
my_speed.z+=2-random(4);
}
/////////////////////////////////////////////////////////////////
// The following definitions are for the pro edition window composer
// to define the start and exit window of the application.
WINDOW WINSTART
{
	TITLE			"A4 Engine";
	SIZE			480,320;
	MODE			IMAGE;	//STANDARD;
	BG_COLOR		RGB(240,240,240);
	FRAME			FTYP1,0,0,480,320;
//	BUTTON		BUTTON_START,SYS_DEFAULT,"Start",400,288,72,24;
	BUTTON		BUTTON_QUIT,SYS_DEFAULT,"Abort",400,288,72,24;
	TEXT_STDOUT	"Arial",RGB(0,0,0),10,10,460,280;
}

/* no exit window at all..
WINDOW WINEND
{
	TITLE			"Finished";
	SIZE			540,320;
	MODE	 		STANDARD;
	BG_COLOR		RGB(0,0,0);
	TEXT_STDOUT	"",RGB(255,40,40),10,20,520,270;

	SET FONT		"",RGB(0,255,255);
	TEXT			"Any key to exit",10,270;
}*/

/////////////////////////////////////////////////////////////////
//INCLUDE <debug.wdl>;
